#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit_proc()
{
    exit(0);
}

void main(void)
{
    Display* disp;
    WinObj* top;
    WinObj* quit;
    WinObj* text1;
    WinObj* text2;
    Pixel fg;
    Pixel bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 400, 170, fg, bg);

    quit = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    text1 = create_LineText   (top, 10, 70,  380, 30, 2, font, "Text1:");
    text2 = create_DirLineText(top, 10, 130, 380, 30, 2, font, "Text2:");

    WinObjRealize(top);
    MainLoop();
}
