#ifndef ___SSDEFS_H_
#define ___SSDEFS_H_

#define SAMPLES      8000
/*
#define MAGSTEP      2
*/
#define GAP 16
#define BD_WIDTH 2
#define WAVE_NPOINTS (8 * 32u)
#define SCOPE_PARTITION_WIDTH 30

#define WATER_FALL_MOVE_STEP 1
#define MAX_WATER_HEIGHT 50
#define WATER_WIDTH      (WIN_WIDTH / MAGSTEP)
#define START_WATER_X    (WATER_WIN_WIDTH - WATER_WIDTH - 5)
#define START_WATER_Y    (MAX_WATER_HEIGHT + 20)
#define GC_CHAR_WIDTH    6
#define SOUNDSCOPE_DEFAULT_BUFFER_NAME "S o u n d S c o p e"

#define WINOBJ_EVENT_FRAME(winobj) ((SSFrame *)((WinObj *)(winobj))->any.ext_data)
#define ISMONODISP (display_visual_type == DISPLAY_VISUAL_MONO)
#define CLIP_SHORT(x) ((x) < SHRT_MIN ? SHRT_MIN : (x) > SHRT_MAX ? SHRT_MAX : (short)(x))
#define FIXREGION(x, min, max) if(x < min) x = min; else if(x > max) x = max
#define SWAP(a, b, tmp) tmp = a; a = b; b = tmp

#define USE_FILE_MAP
#define AUDIO_BUCKET_LEN 4096	/* 8 ܿǤ뤳 */
#define DATA_FRAGMENTATION_SIZE 32768
#define MAX_BUCKET_NCHANNELS 8
#define MIN_SAMPLE_RATE 1000
#define MAX_SAMPLE_RATE 99999
#define FFTSIZE 512
#define MIN_WAVE_ZOOM 128
#define MAX_NPOINTS 1024
#define LOG_HZ_MIN_X1 1.0
#define LOG_HZ_MAX_X1 50.0
#define SOUNDSCOPE_WINDOW_TITLE "soundscope " VERSION
#define SOUNDSCOPE_ICON_TITLE   "Soundscope"
#define DEFAULT_SCOPE_WIDTH  768
#define DEFAULT_SCOPE_HEIGHT 256
#define PUBLIC
#ifdef sun
#ifndef memmove
#define memmove(a, b, n) bcopy(b, a, n)
#endif /* memmove */
#endif /* sun */

#endif /* ___SSDEFS_H_ */
