#ifndef ___SSFRAME_H_
#define ___SSFRAME_H_

#include "convolution.h"	/* CONVOLUTION_SIZE */

/* ssframe - soundscope frame
 * soundscope Υե졼๽¤ΤǤΥե졼Ƥ WinObj 
 * ext_data ݥ󥿤˼ʬƤե졼๽¤ΤؤΥݥ󥿤
 * ꤵƤޤ
 * ե졼๽¤Τˤϼ˰ʲξޤ
 *
 * WinObj Υȥåץ٥륦ɥ
 * ߤαհ֤ɽ饤
 * ݥåץåץ˥塼
 * AudioBuffer ؤΥݥ
 * ѤγƼѿ
 * ʤɡ
 *
 *
 */

/* ʲΤ褦Τʤˤʤޤ

X Υ٥
    -> WinObj  EventHandler  CallBack θƤӽФ
	-> ext_data  SSFrame Τ롥
	    -> aubuff 顤оݤ Audio ХåեΤ롥
	-> ȯ٥ȤAudio Хåեξ֤򸵤ˡ
	   ưꤹ롥

*/

/* scope_main_mode */
enum scope_main_mode_t
{
    SCOPE_WAVE,
    SCOPE_SPECTORAM,
    SCOPE_SPECTOROGRAM,
    SCOPE_EDIT,
    SCOPE_NMODE
};

/* scope_local_mode */
enum scope_local_mode_t
{
    SCOPE_HZ_LOG,
    SCOPE_WAVEFORM,
    SCOPE_SPECGTYPE,
    SCOPE_NLOCAL_MODE
};

typedef struct _scope_wave_measure_t
{
    int x_left;
    int x_right;
    int y;
    int status;
    int px, py;
} scope_wave_measure_t;

enum measure_status
{
    /* None */
    MEASURE_MOVE = 1,
    MEASURE_EXTEND_LEFT,
    MEASURE_EXTEND_RIGHT
};

typedef struct _SSFrame
{
    WinObj* toplevel;		/* ȥåץ٥ WinObjNULL ʤѡ*/
    WinObj* play_slider;	/* ߤαհ֤ɽ饤 */
    WinObj* edit_slider;	/* Խ̤ΰֻѥ饤 */
    WinObj* dir_text;		/* եѥƥ */
    WinObj* load_button;	/* ɥܥ */
    WinObj* buffer_label;	/* Хåե̾ */
    WinObj* zoom_slider;	/* ɽѥ顼 */
    WinObj* scope_winobj;	/* scope */
    WinObj* volume_slider;
    WinObj* srcustom;		/* ॵץ졼ѥɥ */
    WinObj* srcustom_slider;	/* ॵץ졼ȥ饤 */
    WinObj* srcustom_text;	/* ॵץ졼ȥƥ */

    /* ݥåץåץ˥塼 */
    WinObj* file_popup;		/* ե */
    WinObj* sound_attri_popup;	/* ° */
    WinObj* sound_edit_popup;	/* Խ */
    WinObj* sound_win_popup;	/* ɥ */
    WinObj* sample_rate_popup;	/* ץ졼 */
    WinObj* output_popup;	/*  */
    WinObj* encoding_popup;	/* 沽 */
    WinObj* channel_popup;	/* ͥ */

    Bool play_slider_grab_flag;	/* True ʤ play_slider ư */
    struct _AudioPlayer* player; /* ǥץ쥤䡼 */
    Bool mapflag;		/* Ļ֤ʤ True */

    /* ѤγƼѿ */
    WinObj* scope_main_mode;	/* ɽˡ */
    WinObj* local_mode_selector[SCOPE_NLOCAL_MODE]; /* ٤ɽˡ */
    Window scope_win;		/* scope Υɥ */
    Pixmap scope_pm;		/* scope ѥԥåޥå */
    Pixmap scope_background;	/* scope ѥԥåޥå */
    Pixmap ed_cur_pm;		/* edit ѡΥХååפ˻ */
    long ed_cur;		/* ed_cur_pm ΰ (-1 ̤)*/
    double ed_vratio;		/* edit ѡɽ֤γ */
    short scope_width;		/* פ */
    short scope_height;		/* פι⤵ */
    short scope_pixmap_width;	/* Ƥԥåѥåפ */
    short scope_pixmap_height;	/* Ƥԥåѥåפι⤵ */
    long prev_pos[MAX_BUCKET_NCHANNELS]; /* 1 Υפɽ */
    double zoom[SCOPE_NMODE];
    double log_hz_table[FFTSIZE/2];
    double exp_hz_table[FFTSIZE/2];
    double yzoom;		/* ΥΨ */
    Window edit_region_viewer;
    int repaint_y_min, repaint_y_max; /* ®˹ԤΤɬ */
    scope_wave_measure_t measure;

    /* 饤 */
    Bool equlizing_flag;	/* True ʤ aubuff Ф convolution */
    double convolution[CONVOLUTION_SIZE/2+1]; /*  򤫤 */
    WinObj* equlizer;
    WinObj* equlizer_gp;
    WinObj* equlizer_query;
    int equlizer_measure_start;	/* ɽΥǥ٥κͤ YRESOLUTION 
				 * ͡᥸㡼 1 Ĳ˥뤹
				 *  1 롥
				 */
    int equlizer_measure_zero;	/* 0 ǥ٥ΤȤ YRESOLUTION ܤ͡
				 * ᥸㡼 1 Ĳ˥뤹 1 롥
				 */

    struct _SSFrame* next;	/* ¾Υե졼ؤλȤ
				 * Ԥʤ٤Υꥹ
				 */
} SSFrame;

SSFrame* alloc_ssframe(void);
/* SSFrame ѤΥݤޤƤ SSFrame Ϥδؿ̤ƺ
 * ʤФʤޤ
 * Ԥȥåɽ塤 NULL ֤ޤ
 */

void delete_ssframe(SSFrame* frame);
/* frame ޤframe  WinObj Ϻޤ
 * Ǥ frame Ѥʤʤˤ⤷ޤ
 */

int number_of_ssframes(void);
/* ե졼֤ޤ*/

void SSFrameMapFuntion(void (* map_function)(SSFrame* frame));
/* ơΥե졼Ф map_function ȯԤޤ*/



void draw_measure(Display* disp, Drawable win,
		  scope_wave_measure_t* measure);
Bool measure_event_proc(SSFrame* frame, XEvent* e);

#define DEFAULT_SCOPE_MAIN_MODE SCOPE_WAVE
#define SSFRAME_AVAILABLE(frame) ((frame) != NULL && (frame)->toplevel != NULL)
#define SSFRAME_SCOPE_MAIN_MODE(frame) ((frame)->scope_main_mode->choice.selected)

extern SSFrame* all_frame_list;	/* ѤΥե졼Υꥹ */

#endif /* ___SSFRAME_H_ */
