#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit_proc()
{
    exit(0);
}

void print_hello()
{
    puts("hello, world.");
}

void main(void)
{
    WinObj* top;
    WinObj* btn;
    WinObj* quit;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "white");
    bg = AllocNamedColor(disp, "gray");

    font = CreateCharFont(disp, "a14", "k14");
    top = toplevel_WinObj(disp, "test", "Test", 800, 300,
                          fg, bg);

    btn = create_Button(top,
			100, 100,
			200, 150,
			2,
			font, "<<ˤ>>");
    SetCallBackProc(btn, print_hello);
    quit = create_Button(top,
			 10, 10,
			 0, 0,
			 2,
			font, "λ");
    SetCallBackProc(quit, quit_proc);

    WinObjRealize(top);
    MainLoop();
}
