#ifndef ___WINOBJ_DEFS_H_
#define ___WINOBJ_DEFS_H_

#ifndef Bool
#define Bool int
#endif

#ifndef False
#define False 0
#endif

#ifndef True
#define True 1
#endif

#ifndef None
#define None 0
#endif

#ifndef Any
#define Any -1
#endif

#ifndef MAX
#define MAX(a, b) ((a) < (b) ? (b) : (a))
#endif

#ifndef MAX3
#define MAX3(a, b, c) MAX(MAX(a, b), c)
#endif

#ifndef MIN
#define MIN(a, b) ((a) > (b) ? (b) : (a))
#endif

#ifndef MIN3
#define MIN3(a, b, c) MIN(MIN(a, b), c)
#endif

#if (XlibSpecificationRelease >= 5)
#define USE_LOCALE 1
#endif

/* let's define Pixel if it is not done yet */
#if ! defined(_XtIntrinsic_h) && ! defined(PIXEL_ALREADY_TYPEDEFED)
typedef unsigned long Pixel;
#define PIXEL_ALREADY_TYPEDEFED
#endif


#endif /* ___WINOBJ_DEFS_H_ */
